#include "system.h"
#include "filosofo.h"


/******************************************************************/
int PalitoLibre(int palito)
{
    if(DatosGlobales->Proceso[PMOZO].Estado==ESTADO_COMIENDO)
    if (DatosGlobales->Proceso[PMOZO].Limpiando==palito)
            return(FALSE);

    if(DatosGlobales->Proceso[palito].Estado==ESTADO_COMIENDO)
        return(FALSE);
    
	if(DatosGlobales->Proceso[(CANT_FIL+palito-1)%CANT_FIL].Estado==ESTADO_COMIENDO)
        return(FALSE);

    return(TRUE);
}

/******************************************************************/
void AsignarPalitos()
{
    //Veo si hay que darle los palitos al mozo
    if(DatosGlobales->Proceso[PMOZO].Estado==ESTADO_ESPERANDO_PALITOS)
    {
	    int i=DatosGlobales->Proceso[PMOZO].Limpiando+1;
        Assert( (i>=0) && (i<CANT_FIL) );

        if (PalitoLibre(i))
        {
            LogPrint("(Palitos) Se asigna palito al mozo: %i",i);
            DatosGlobales->Proceso[PMOZO].Estado=ESTADO_COMIENDO;
            DatosGlobales->Proceso[PMOZO].Limpiando=i;
            SendSignal(DatosGlobales->Proceso[PMOZO].pid,SIG_RECIVEPALITOS);
        }
    }

    //Veo si puedo darle palitos a algun filosofo
    for (int i=0;i<CANT_FIL;i++)
    {
        if(DatosGlobales->Proceso[i].Estado!=ESTADO_ESPERANDO_PALITOS)
            continue;
        if (!PalitoLibre(i))
            continue;
        if (!PalitoLibre((i+1)%CANT_FIL))
            continue;

        LogPrint("(Palitos) Se asignan palitos al filosofo %i",i);
        DatosGlobales->Proceso[i].Estado=ESTADO_COMIENDO;

        //Aviso al filosofo que tiene los palitos
        SendSignal(DatosGlobales->Proceso[i].pid,SIG_RECIVEPALITOS);
    }
}

/******************************************************************/
void PalitosSignal(int sig)
{
    signal(SIG_DARPALITOS,(SIG_PF)PalitosSignal);
    Assert(sig==SIG_DARPALITOS);

    //LogPrint("(Palitos) Alarma :%i",sig);
}

/******************************************************************/
void AdministradorPalitos(int nada)
{
    (void)nada;
    LogPrint("(Palitos) Comienza Inicializacion");

    AttachSharedMem();
    DatosGlobales->pid_AdministradorPalitos=getpid();
    signal(SIG_DARPALITOS,(SIG_PF)PalitosSignal);

    LogPrint("(Palitos) Fin Inicializacion");

    pause();
    while(!DatosGlobales->TerminarFlag)
    {
		WaitSemaf();

		AsignarPalitos();

		SignalSemaf();
		pause();
    }

    DettachSharedMem();
    LogPrint("(Palitos) Termina");
}


/******************************************************************/
/******************************************************************/
